io.undertow.attribute

## Class ResponseTimeAttribute

- java.lang.Object
- - io.undertow.attribute.ResponseTimeAttribute

All Implemented Interfaces:
  ExchangeAttribute

    public class ResponseTimeAttribute
    extends Object
    implements ExchangeAttribute

The response time This will only work if `UndertowOptions.RECORD_REQUEST_START_TIME` has been set

### Nested Class Summary

Nested Classes
`static class` `ResponseTimeAttribute.Builder`

### Field Summary

Fields
`static String` `RESPONSE_TIME_MICROS`
`static String` `RESPONSE_TIME_MILLIS`
`static String` `RESPONSE_TIME_MILLIS_SHORT`
`static String` `RESPONSE_TIME_NANOS`
`static String` `RESPONSE_TIME_SECONDS_SHORT`

### Constructor Summary

Constructors
Constructor and Description
`ResponseTimeAttribute(TimeUnit timeUnit)`

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `readAttribute(HttpServerExchange exchange)` Resolve the attribute from the HTTP server exchange.
`String` `toString()`
`void` `writeAttribute(HttpServerExchange exchange, String newValue)` Sets a new value for the attribute.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### RESPONSE_TIME_MILLIS_SHORT

    public static final String RESPONSE_TIME_MILLIS_SHORT

See Also:
  Constant Field Values

#### RESPONSE_TIME_SECONDS_SHORT

    public static final String RESPONSE_TIME_SECONDS_SHORT

See Also:
  Constant Field Values

#### RESPONSE_TIME_MILLIS

    public static final String RESPONSE_TIME_MILLIS

See Also:
  Constant Field Values

#### RESPONSE_TIME_MICROS

    public static final String RESPONSE_TIME_MICROS

See Also:
  Constant Field Values

#### RESPONSE_TIME_NANOS

    public static final String RESPONSE_TIME_NANOS

See Also:
  Constant Field Values

### Constructor Detail

#### ResponseTimeAttribute

    public ResponseTimeAttribute(TimeUnit timeUnit)

### Method Detail

#### readAttribute

    public String readAttribute(HttpServerExchange exchange)

Description copied from interface: `ExchangeAttribute`
Resolve the attribute from the HTTP server exchange. This may return null if the attribute is not present.

Specified by:
  `readAttribute` in interface `ExchangeAttribute`
Parameters:
  `exchange` - The exchange
Returns:
  The attribute

#### writeAttribute

    public void writeAttribute(HttpServerExchange exchange,
                               String newValue)
                        throws ReadOnlyAttributeException

Description copied from interface: `ExchangeAttribute`
Sets a new value for the attribute. Not all attributes are writable.

Specified by:
  `writeAttribute` in interface `ExchangeAttribute`
Parameters:
  `exchange` - The exchange
  `newValue` - The new value for the attribute
Throws:
  `ReadOnlyAttributeException` - when attribute cannot be written

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`